/*  Last edited: Apr 10 15:30 2002 (mng) */
#ifndef _CAF_FIND_MISASSEMBLIES_H_
#define _CAF_FIND_MISASSEMBLIES_H_

#define  BAD   75.0
#define  HIGH  20

#define min(a, b) ((a) < (b) ? (a) : (b))
#define max(a, b) ((a) > (b) ? (a) : (b))


typedef struct {
  CAFSEQ *read;  /* Read info            */
  int cs;        /* Start in contig      */
  int ce;        /* End in contig + 1    */
  int rs;        /* Start in read        */
  int re;        /* End in read + 1      */
  int comp;      /* Align reverse strand */
} Seg_entry;

typedef struct {
  CAFSEQ *rs;  // pointer to read object.
  int qual;    // quality
  int pos;     // real position within read.
} high_qual;

typedef struct {
  int read;
  int align;
  int match;
} To_tag;

void usage (void);

int find_misassemblies(cafAssembly *,double, int, FILE*);

static void update_segments(cafAssembly *, int , Array,
                            ASSINF **, ASSINF *);

static void check_base(cafAssembly* caf, CAFSEQ* contig,
		       int i, Array segments, Array tag_info, void * params,
		       FILE *log);

static int af_compare(const void *, const void *);

static int seg_compare(const void *, const void *);

static char complement(char b);

typedef void (*do_iterator_callback)(cafAssembly*,CAFSEQ*, int, Array, Array, void *, FILE *);

static int tag_misassemblies(cafAssembly *, Array, int , FILE *);

#endif /*_CAF_FIND_MISASSEMBLIES_H_*/
